/* auto-generated by gensrv_cpp from /opt/ros/boxturtle/stacks/pr2_power_drivers/pr2_power_board/srv/PowerBoardCommand2.srv.  Do not edit! */
#ifndef SRV_PR2_POWER_BOARD_POWERBOARDCOMMAND2_H
#define SRV_PR2_POWER_BOARD_POWERBOARDCOMMAND2_H

#include <string>
#include <cstring>
#include <vector>
#include <map>
#include "ros/message.h"
#include "ros/time.h"

namespace pr2_power_board
{

struct PowerBoardCommand2
{

inline static std::string getDataType() { return "pr2_power_board/PowerBoardCommand2"; }
inline static std::string getMD5Sum() { return "4f143c27e05688798e6220ba69c6906a"; }

//! \htmlinclude Request.msg.html

class Request : public ros::Message
{
public:
  typedef boost::shared_ptr<Request> Ptr;
  typedef boost::shared_ptr<Request const> ConstPtr;

  typedef int32_t _circuit_type;
  typedef std::string _command_type;
  typedef uint8_t _reset_stats_type;
  typedef uint8_t _reset_circuits_type;

  const static int32_t NUMBER_OF_CIRCUITS = 3;
  int32_t circuit;
  const static int32_t BASE = 0;
  const static int32_t RIGHT_ARM = 1;
  const static int32_t LEFT_ARM = 2;
  std::string command;
  uint8_t reset_stats;
  uint8_t reset_circuits;

  Request() : ros::Message(),
    circuit(0),
    reset_stats(0),
    reset_circuits(0)
  {
  }
  Request(const Request &copy) : ros::Message(),
    circuit(copy.circuit),
    command(copy.command),
    reset_stats(copy.reset_stats),
    reset_circuits(copy.reset_circuits)
  {
    (void)copy;
  }
  Request &operator =(const Request &copy)
  {
    if (this == &copy)
      return *this;
    circuit = copy.circuit;
    command = copy.command;
    reset_stats = copy.reset_stats;
    reset_circuits = copy.reset_circuits;
    return *this;
  }
  virtual ~Request() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("pr2_power_board/PowerBoardCommand2Request"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "int32 NUMBER_OF_CIRCUITS = 3\n"
    "#\n"
    "# Select which circuit to command\n"
    "#\n"
    "int32 circuit\n"
    "#\n"
    "# Defined circuits\n"
    "#\n"
    "int32 BASE      = 0\n"
    "int32 RIGHT_ARM = 1\n"
    "int32 LEFT_ARM  = 2\n"
    "#\n"
    "# Command to send to circuit:\n"
    "# command = start, stop, reset, disable, none\n"
    "#\n"
    "string command  \n"
    "#\n"
    "# reset the latched voltage and current statistics\n"
    "bool reset_stats\n"
    "#\n"
    "# reset the latched stats for each circuit\n"
    "bool reset_circuits\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("4f143c27e05688798e6220ba69c6906a"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("pr2_power_board/PowerBoardCommand2"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 0; // NUMBER_OF_CIRCUITS
    __l += 4; // circuit
    __l += 0; // BASE
    __l += 0; // RIGHT_ARM
    __l += 0; // LEFT_ARM
    __l += 4 + command.length(); // command
    __l += 1; // reset_stats
    __l += 1; // reset_circuits
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    SROS_SERIALIZE_PRIMITIVE(write_ptr, circuit);
    unsigned __ros_command_len = command.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_command_len);
    SROS_SERIALIZE_BUFFER(write_ptr, command.c_str(), __ros_command_len);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, reset_stats);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, reset_circuits);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, circuit);
    unsigned __ros_command_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_command_len);
    command = std::string((const char *)read_ptr, __ros_command_len);
    read_ptr += __ros_command_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, reset_stats);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, reset_circuits);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Request> RequestPtr;
typedef boost::shared_ptr<Request const> RequestConstPtr;

//! \htmlinclude Response.msg.html

class Response : public ros::Message
{
public:
  typedef boost::shared_ptr<Response> Ptr;
  typedef boost::shared_ptr<Response const> ConstPtr;

  typedef uint8_t _success_type;

  uint8_t success;

  Response() : ros::Message(),
    success(0)
  {
  }
  Response(const Response &copy) : ros::Message(),
    success(copy.success)
  {
    (void)copy;
  }
  Response &operator =(const Response &copy)
  {
    if (this == &copy)
      return *this;
    success = copy.success;
    return *this;
  }
  virtual ~Response() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("pr2_power_board/PowerBoardCommand2Response"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# return if the command was successfully sent\n"
    "bool success\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("4f143c27e05688798e6220ba69c6906a"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("pr2_power_board/PowerBoardCommand2"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 1; // success
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    SROS_SERIALIZE_PRIMITIVE(write_ptr, success);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, success);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Response> ResponsePtr;
typedef boost::shared_ptr<Response const> ResponseConstPtr;

Request request;
Response response;

};

}

#endif
